import React from 'react';
import type { NamespaceItemCardProps } from './namespace-card';
import type { ViewType } from './use-view-type';
type Item = {
    _id: string;
} & Record<string, unknown>;
export declare const createButtonStyles: string;
type CallbackProps = {
    onItemClick(id: string): void;
    onCreateItemClick?: () => void;
    onDeleteItemClick?: (id: string) => void;
};
interface RenderItem<T> {
    (props: {
        item: T;
        viewType: ViewType;
    } & Omit<CallbackProps, 'onCreateItemClick'> & Omit<React.HTMLProps<HTMLDivElement>, Extract<keyof NamespaceItemCardProps, string>>): React.ReactElement;
}
type ItemsGridProps<T> = {
    namespace?: string;
    itemType: 'collection' | 'database';
    itemGridWidth: number;
    itemGridHeight: number;
    itemListWidth?: number;
    itemListHeight?: number;
    items: T[];
    sortBy?: {
        name: Extract<keyof T, string>;
        label: string;
    }[];
    onItemClick(id: string): void;
    onDeleteItemClick?: (id: string) => void;
    onCreateItemClick?: () => void;
    onRefreshClick?: () => void;
    renderItem: RenderItem<T>;
    renderLoadSampleDataBanner?: () => React.ReactNode;
};
export declare const ItemsGrid: <T extends Item>({ namespace, itemType, itemGridWidth, itemGridHeight, itemListWidth, itemListHeight, items, sortBy, onItemClick, onDeleteItemClick, onCreateItemClick, onRefreshClick, renderItem: _renderItem, renderLoadSampleDataBanner, }: ItemsGridProps<T>) => React.ReactElement;
export {};
//# sourceMappingURL=items-grid.d.ts.map