"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemsGrid = exports.createButtonStyles = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const provider_1 = require("@mongodb-js/compass-telemetry/provider");
const use_view_type_1 = require("./use-view-type");
const provider_2 = require("@mongodb-js/compass-connections/provider");
const mongodb_ns_1 = __importDefault(require("mongodb-ns"));
const connection_info_1 = require("@mongodb-js/connection-info");
const provider_3 = require("@mongodb-js/compass-workspaces/provider");
const provider_4 = require("@mongodb-js/compass-connections/provider");
const provider_5 = require("compass-preferences-model/provider");
const rowStyles = (0, compass_components_1.css)({
    paddingLeft: compass_components_1.spacing[3],
    paddingRight: compass_components_1.spacing[3],
    paddingBottom: compass_components_1.spacing[2],
    columnGap: compass_components_1.spacing[2],
});
const containerStyles = (0, compass_components_1.css)({
    width: '100%',
    height: '100%',
    overflow: 'hidden',
    display: 'grid',
    gridTemplateRows: 'auto 1fr',
    gridTemplateColumns: '100%',
    outline: 'none',
});
exports.createButtonStyles = (0, compass_components_1.css)({
    whiteSpace: 'nowrap',
});
const controlsContainerStyles = (0, compass_components_1.css)({
    paddingTop: compass_components_1.spacing[200],
    paddingRight: compass_components_1.spacing[400],
    paddingBottom: compass_components_1.spacing[400],
    paddingLeft: compass_components_1.spacing[400],
    display: 'grid',
    gridTemplate: '1fr / 100%',
    gap: compass_components_1.spacing[200],
});
const controlRowStyles = (0, compass_components_1.css)({
    display: 'flex',
    alignItems: 'center',
    gap: compass_components_1.spacing[200],
});
const controlStyles = (0, compass_components_1.css)({
    flex: 'none',
});
const breadcrumbContainerStyles = (0, compass_components_1.css)({
    display: 'flex',
    minWidth: 0,
    paddingTop: compass_components_1.spacing[200],
    paddingBottom: compass_components_1.spacing[200],
});
const pushRightStyles = (0, compass_components_1.css)({
    marginLeft: 'auto',
});
const bannerRowStyles = (0, compass_components_1.css)({
    paddingTop: compass_components_1.spacing[200],
});
function buildChartsUrl(groupId, clusterName, namespace) {
    const { database } = (0, mongodb_ns_1.default)(namespace ?? '');
    const url = new URL(`/charts/${groupId}`, window.location.origin);
    url.searchParams.set('sourceType', 'cluster');
    url.searchParams.set('instanceName', clusterName);
    if (database) {
        url.searchParams.set('database', database);
    }
    return url.toString();
}
const GridControls = ({ namespace, itemType, sortControls, viewTypeControls, onCreateItemClick, onRefreshClick, renderLoadSampleDataBanner, }) => {
    const connectionInfo = (0, provider_2.useConnectionInfo)();
    const connectionTitle = (0, connection_info_1.getConnectionTitle)(connectionInfo);
    const { openDatabasesWorkspace, openCollectionsWorkspace, openShellWorkspace, } = (0, provider_3.useOpenWorkspace)();
    const { enableShell, enableNewMultipleConnectionSystem } = (0, provider_5.usePreferences)([
        'enableShell',
        'enableNewMultipleConnectionSystem',
    ]);
    const showOpenShellButton = enableShell && enableNewMultipleConnectionSystem;
    const breadcrumbs = (0, react_1.useMemo)(() => {
        const { database } = (0, mongodb_ns_1.default)(namespace ?? '');
        const items = [
            {
                name: connectionTitle,
                onClick: () => {
                    openDatabasesWorkspace(connectionInfo.id);
                },
            },
        ];
        if (database) {
            items.push({
                name: database,
                onClick: () => {
                    openCollectionsWorkspace(connectionInfo.id, database);
                },
            });
        }
        return items;
    }, [
        connectionInfo.id,
        connectionTitle,
        namespace,
        openCollectionsWorkspace,
        openDatabasesWorkspace,
    ]);
    const banner = renderLoadSampleDataBanner?.();
    return (react_1.default.createElement("div", { className: controlsContainerStyles },
        react_1.default.createElement("div", { className: controlRowStyles },
            react_1.default.createElement("div", { className: breadcrumbContainerStyles },
                react_1.default.createElement(compass_components_1.Breadcrumbs, { items: breadcrumbs })),
            react_1.default.createElement("div", { className: (0, compass_components_1.cx)(controlRowStyles, controlStyles, pushRightStyles) },
                showOpenShellButton && (react_1.default.createElement(compass_components_1.Button, { size: "small", onClick: () => {
                        openShellWorkspace(connectionInfo.id, namespace
                            ? { initialEvaluate: `use ${namespace}` }
                            : undefined);
                    }, leftGlyph: react_1.default.createElement(compass_components_1.Icon, { glyph: "Shell" }) }, "Open MongoDB shell")),
                connectionInfo.atlasMetadata && (react_1.default.createElement(compass_components_1.Button, { "data-testid": `${itemType}-header-visualize-your-data`, size: "small", href: buildChartsUrl(connectionInfo.atlasMetadata.projectId, connectionInfo.atlasMetadata.clusterName, namespace), target: "_self", rel: "noopener noreferrer", leftGlyph: react_1.default.createElement(compass_components_1.Icon, { glyph: "Charts" }) }, "Visualize your data")),
                onCreateItemClick && (react_1.default.createElement("div", { className: controlStyles, "data-testid": "create-controls" },
                    react_1.default.createElement(compass_components_1.Button, { variant: "primary", leftGlyph: react_1.default.createElement(compass_components_1.Icon, { role: "presentation", glyph: "Plus" }), onClick: onCreateItemClick, className: exports.createButtonStyles, size: "small" },
                        "Create ",
                        itemType))),
                onRefreshClick && (react_1.default.createElement("div", { className: controlStyles, "data-testid": "refresh-controls" },
                    react_1.default.createElement(compass_components_1.Button, { variant: "default", leftGlyph: react_1.default.createElement(compass_components_1.Icon, { role: "presentation", glyph: "Refresh" }), onClick: onRefreshClick, size: "small" }, "Refresh"))))),
        sortControls && viewTypeControls && (react_1.default.createElement("div", { className: controlRowStyles },
            react_1.default.createElement("div", { className: controlStyles }, sortControls),
            react_1.default.createElement("div", { className: (0, compass_components_1.cx)(controlStyles, pushRightStyles) }, viewTypeControls))),
        banner && react_1.default.createElement("div", { className: bannerRowStyles }, banner)));
};
const itemsGridContainerStyles = (0, compass_components_1.css)({
    width: '100%',
    height: '100%',
});
const ItemsGrid = ({ namespace, itemType, itemGridWidth, itemGridHeight, itemListWidth = itemGridWidth, itemListHeight = itemGridHeight, items, sortBy = [], onItemClick, onDeleteItemClick, onCreateItemClick, onRefreshClick, renderItem: _renderItem, renderLoadSampleDataBanner, }) => {
    const track = (0, provider_1.useTelemetry)();
    const connectionInfoAccess = (0, provider_4.useConnectionInfoAccess)();
    const onViewTypeChange = (0, react_1.useCallback)((newType) => {
        track('Switch View Type', { view_type: newType, item_type: itemType }, connectionInfoAccess.getCurrentConnectionInfo());
    }, [itemType, track, connectionInfoAccess]);
    const [sortControls, sortState] = (0, compass_components_1.useSortControls)(sortBy);
    const [viewTypeControls, viewType] = (0, use_view_type_1.useViewTypeControls)({
        onChange: onViewTypeChange,
    });
    const sortedItems = (0, compass_components_1.useSortedItems)(items, sortState);
    const itemWidth = viewType === 'grid' ? itemGridWidth : itemListWidth;
    const itemHeight = viewType === 'grid' ? itemGridHeight : itemListHeight;
    const shouldShowControls = items.length > 0;
    const renderItem = (0, react_1.useCallback)(({ index, ...props }) => {
        const item = sortedItems[index];
        return _renderItem({
            item,
            viewType,
            onItemClick,
            onDeleteItemClick,
            ...props,
        });
    }, [_renderItem, onDeleteItemClick, onItemClick, sortedItems, viewType]);
    return (react_1.default.createElement("div", { className: itemsGridContainerStyles },
        react_1.default.createElement(compass_components_1.WorkspaceContainer, { toolbar: react_1.default.createElement(GridControls, { itemType: itemType, namespace: namespace, sortControls: shouldShowControls ? sortControls : undefined, viewTypeControls: shouldShowControls ? viewTypeControls : undefined, onCreateItemClick: onCreateItemClick, onRefreshClick: onRefreshClick, renderLoadSampleDataBanner: renderLoadSampleDataBanner }) }, (scrollTriggerRef) => {
            return (react_1.default.createElement(compass_components_1.VirtualGrid, { itemMinWidth: itemWidth, itemHeight: itemHeight + compass_components_1.spacing[2], itemsCount: sortedItems.length, colCount: viewType === 'list' ? 1 : undefined, renderItem: renderItem, renderHeader: () => {
                    return react_1.default.createElement("div", { ref: scrollTriggerRef });
                }, headerHeight: 0, itemKey: (index) => sortedItems[index]._id, classNames: { container: containerStyles, row: rowStyles }, resetActiveItemOnBlur: false, "data-testid": `${itemType}-grid` }));
        })));
};
exports.ItemsGrid = ItemsGrid;
//# sourceMappingURL=items-grid.js.map